library IEEE;
 use IEEE.std_logic_1164.all;
 use ieee.numeric_std.all;

entity myComponent is
    generic (
        gComponentIndex : integer range 0 to 31
    );
    port
    (
        iSysRst : in  std_logic;
        iSysClk : in  std_logic;
        iBit    : in  std_logic;
        iVector : in  std_logic_vector( 15 downto 0);
        oBit    : out std_logic;
        oVector : out std_logic_vector( 15 downto 0)
    );
end myComponent;

architecture RTL of myComponent is
begin
    plMyProcess : process (iSysRst, iSysClk)
    begin
        if rising_edge(iSysClk) then

            if gComponentIndex < 16 then
                oVector(gComponentIndex) <= iBit;
            end if;

            if (gComponentIndex > 16) and (gComponentIndex < 32) then
                oVector(gComponentIndex - 16) <= iBit;
            end if;

            if gComponentIndex < 16 then
                oBit  <= iVector(gComponentIndex);
            end if;

            if gComponentIndex >= 16 and gComponentIndex < 32 then
                oBit  <= iVector(gComponentIndex - 16);
            end if;

            if iSysRst = '1' then
                oBit    <= '0';
                oVector <= (others => '0');
            end if;
        end if; -- rising_edge(iSysClkC)
    end process;

end RTL;