library ieee;
 use ieee.std_logic_1164.all;
 use ieee.numeric_std.all;


entity myTestbench is
end myTestbench ;


architecture Arch of myTestbench is


    component myComponent is
        generic (
            gComponentIndex : integer range 0 to 31
        );
        port
        (
            iSysRst : in  std_logic;
            iSysClk : in  std_logic;

            iBit    : in  std_logic;
            iVector : in  std_logic_vector( 15 downto 0);
            oBit    : out std_logic;
            oVector : out std_logic_vector( 15 downto 0)
        );
    end component myComponent;

    

    constant cSysClkPeriod  : time  := 1000.0 ns / 100; --100 MHz
    signal sSysRst          : std_logic;
    signal sSysClk          : std_logic;
    signal siBit            : std_logic;
    signal siVector         : std_logic_vector(15 downto 0);
    signal soBit1           : std_logic;
    signal soVector1        : std_logic_vector(15 downto 0);
    signal soBit2           : std_logic;
    signal soVector2        : std_logic_vector(15 downto 0);
    

begin

    
  --  reset generation
  sSysRst  <= '0', '1' after 20 * cSysClkPeriod;

  -- Clock generation
  plClkGeneration: process
  begin
    sSysClk <= '0';
    wait for cSysClkPeriod /2;
    sSysClk <= '1';
    wait for cSysClkPeriod /2;
  end process;

    ilmyComponent_1 : myComponent
    generic map (
       gComponentIndex => 1
    )
    port map (
        iSysRst => sSysRst,
        iSysClk => sSysClk,
        iBit    => siBit,
        iVector => siVector,
        oBit    => soBit1,
        oVector => soVector1
    );
    
    ilmyComponent_16 : myComponent
    generic map (
       gComponentIndex => 16
    )
    port map (
        iSysRst => sSysRst,
        iSysClk => sSysClk,
        iBit    => siBit,
        iVector => siVector,
        oBit    => soBit2,
        oVector => soVector2
    );


end Arch;
