library ieee;
 use ieee.std_logic_1164.all;
 use ieee.numeric_std.all;


entity myTop is
    port(
        iSysRst          : in  std_logic;
        iSysClk          : in  std_logic;
        iBit             : in  std_logic;
        iVector          : in  std_logic_vector(15 downto 0);
        oBit1            : out std_logic;
        oBit2            : out std_logic;
        oVector          : out std_logic_vector(15 downto 0)
    );
end myTop ;


architecture Arch of myTop is


    component myComponent is
        generic (
            gComponentIndex : integer range 0 to 31
        );
        port
        (
            iSysRst : in  std_logic;
            iSysClk : in  std_logic;
            iBit    : in  std_logic;
            iVector : in  std_logic_vector(15 downto 0);
            oBit    : out std_logic;
            oVector : out std_logic_vector(15 downto 0)
        );
    end component myComponent;

    signal sVector1 : std_logic_vector(15 downto 0);
    signal sVector2 : std_logic_vector(15 downto 0);


begin

    ilmyComponent_1 : myComponent
    generic map (
       gComponentIndex => 0
    )
    port map (
        iSysRst => iSysRst,
        iSysClk => iSysClk,
        iBit    => iBit,
        iVector => iVector,
        oBit    => oBit1,
        oVector => sVector1
    );

    ilmyComponent_16 : myComponent
    generic map (
       gComponentIndex => 17
    )
    port map (
        iSysRst => iSysRst,
        iSysClk => iSysClk,
        iBit    => iBit,
        iVector => iVector,
        oBit    => oBit2,
        oVector => sVector2
    );

    oVector <= sVector1 or sVector2;

end Arch;
